]> git.madduck.net Git - code/myrepos.git/blobdiff - mr

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

* Signal handling for commands run by mr, including handling of SIGINT
[code/myrepos.git] / mr
diff --git a/mr b/mr
index f725318b0dfea0f69f67d57a4ed25a8123245a8f..d4c3b250f1a6bca1d86454e3998c730f8041d827 100755 (executable)
--- a/mr
+++ b/mr
@@ -34,12 +34,12 @@ a set of repositories as if they were one combined respository. It
 supports any combination of subversion, git, cvs, and bzr repositories, 
 and support for other revision control systems can easily be added.
 
-B<mr> cds into and operates on all registered repsitories at or below your
+B<mr> cds into and operates on all registered repositories at or below your
 working directory. Or, if you are in a subdirectory of a repository that
 contains no other registered repositories, it will stay in that directory,
 and work on only that repository,
 
-The predefined commands should be fairly familiar to users of any revision
+These predefined commands should be fairly familiar to users of any revision
 control system:
 
 =over 4
@@ -74,6 +74,12 @@ Show a diff of uncommitted changes.
 
 Show the commit log.
 
+=back
+
+These commands are also available:
+
+=over 4
+
 =item list (or ls)
 
 List the repositories that mr will act on.
@@ -81,9 +87,12 @@ List the repositories that mr will act on.
 =item register
 
 Register an existing repository in the mrconfig file. By default, the
-epository in the current directory is registered, or you can specify a
+repository in the current directory is registered, or you can specify a
 directory to register.
 
+By default it registers it to the ~/.mrconfig file. To make it write to a
+different file, use the -c option.
+
 =item config
 
 Adds, modifies, removes, or prints a value from the mrconfig file. The next
@@ -132,6 +141,11 @@ directory.
 
 Be verbose.
 
+=item -s
+
+Expand the statistics line displayed at the end to include information
+about exactly which repositories failed and were skipped, if any.
+
 =back
 
 =head1 FILES
@@ -177,7 +191,7 @@ environment, where any additional parameters you pass are available in
 directory, since the repository isn't checked out yet. All other commands
 are run inside the repository, though not necessarily at the top of it.
 The "MR_REPO" environment variable is set to the path to the top of the
-repository.
+repository, and "MR_CONFIG" is set to the topmost .mrconfig file used.
 
 A few parameters have special meanings:
 
@@ -207,7 +221,7 @@ should avoid chaining from repositories with untrusted committers.)
 
 If the "deleted" parameter is set and its command returns nonzero, then
 B<mr> will treat the repository as deleted. It won't ever actually delete
-the repository, but it will warn if it sees the repsoitory's directory.
+the repository, but it will warn if it sees the repository's directory.
 This is useful when one mrconfig file is shared amoung multiple machines,
 to keep track of and remember to delete old repositories.
 
@@ -236,9 +250,15 @@ use strict;
 use Getopt::Long;
 use Cwd qw(getcwd abs_path);
 
+$SIG{INT}=sub {
+       print STDERR "mr: interrupted\n";
+       exit 2;
+};
+
+$ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
 my $directory=getcwd();
-my $config="$ENV{HOME}/.mrconfig";
 my $verbose=0;
+my $stats=0;
 my %config;
 my %knownactions;
 my %alias;
@@ -246,8 +266,9 @@ my %alias;
 Getopt::Long::Configure("no_permute");
 my $result=GetOptions(
        "d|directory=s" => sub { $directory=abs_path($_[1]) },
-       "c|config=s" => \$config,
-       "verbose" => \$verbose,
+       "c|config=s" => sub { $ENV{MR_CONFIG}=abs_path($_[1]) },
+       "v|verbose" => \$verbose,
+       "s|stats" => \$stats,
 );
 if (! $result || @ARGV < 1) {
        die("Usage: mr [-d directory] action [params ...]\n".
@@ -256,7 +277,7 @@ if (! $result || @ARGV < 1) {
 }
 
 loadconfig(\*DATA);
-loadconfig($config);
+loadconfig($ENV{MR_CONFIG});
 #use Data::Dumper;
 #print Dumper(\%config);
 
@@ -296,7 +317,7 @@ elsif ($action eq 'config') {
        my $section=shift;
        if ($section=~/^\//) {
                # try to convert to a path relative to $config's dir
-               my ($dir)=$config=~/^(.*\/)[^\/]+$/;
+               my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
                if ($section=~/^\Q$dir\E(.*)/) {
                        $section=$1;
                }
@@ -320,7 +341,7 @@ elsif ($action eq 'config') {
                        }
                }
        }
-       modifyconfig($config, $section, %changefields) if %changefields;
+       modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
        exit 0;
 }
 elsif ($action eq 'register') {
@@ -382,10 +403,19 @@ sub action { #{{{
                        my $test="set -e;".$lib.$config{$topdir}{$subdir}{deleted};
                        print "mr $action: running deleted test >>$test<<\n" if $verbose;
                        my $ret=system($test);
-                       if ($ret >> 8 == 0) {
-                               print STDERR "mr error: $dir should be deleted yet still exists\n\n";
-                               push @failed, $dir;
-                               return;
+                       if ($ret != 0) {
+                               if (($? & 127) == 2) {
+                                       print STDERR "mr $action: interrupted\n";
+                                       exit 2;
+                               }
+                               elsif ($? & 127) {
+                                       print STDERR "mr $action: deleted test received signal ".($? & 127)."\n";
+                               }
+                               if ($ret >> 8 == 0) {
+                                       print STDERR "mr error: $dir should be deleted yet still exists\n\n";
+                                       push @failed, $dir;
+                                       return;
+                               }
                        }
                }
        }
@@ -411,10 +441,20 @@ sub action { #{{{
                        "my_action(){ $config{$topdir}{$subdir}{skip}\n }; my_action '$action'";
                print "mr $action: running skip test >>$test<<\n" if $verbose;
                my $ret=system($test);
-               if ($ret >> 8 == 0) {
-                       print "mr $action: $dir skipped per config file\n" if $verbose;
-                       push @skipped, $dir;
-                       return;
+               if ($ret != 0) {
+                       if (($? & 127) == 2) {
+                               print STDERR "mr $action: interrupted\n";
+                               exit 2;
+                       }
+                       elsif ($? & 127) {
+                               print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
+                               exit 1;
+                       }
+                       if ($ret >> 8 == 0) {
+                               print "mr $action: $dir skipped per config file\n" if $verbose;
+                               push @skipped, $dir;
+                               return;
+                       }
                }
        }
        
@@ -439,6 +479,13 @@ sub action { #{{{
                print STDERR "mr $action: running >>$command<<\n" if $verbose;
                my $ret=system($command);
                if ($ret != 0) {
+                       if (($? & 127) == 2) {
+                               print STDERR "mr $action: interrupted\n";
+                               exit 2;
+                       }
+                       elsif ($? & 127) {
+                               print STDERR "mr $action: received signal ".($? & 127)."\n";
+                       }
                        print STDERR "mr $action: failed ($ret)\n" if $verbose;
                        push @failed, $dir;
                        if ($ret >> 8 != 0) {
@@ -449,6 +496,12 @@ sub action { #{{{
                        }
                }
                else {
+                       if ($action eq 'checkout' && ! -d $dir) {
+                               print STDERR "mr $action: $dir missing after checkout\n";;
+                               push @failed, $dir;
+                               return;
+                       }
+
                        push @ok, $dir;
                }
 
@@ -473,6 +526,14 @@ print "mr $action: finished (".join("; ",
        showstat($#failed+1, "failed", "failed"),
        showstat($#skipped+1, "skipped", "skipped"),
 ).")\n";
+if ($stats) {
+       if (@skipped) {
+               print "mr $action: (skipped: ".join(" ", @skipped).")\n";
+       }
+       if (@failed) {
+               print "mr $action: (failed: ".join(" ", @failed).")\n";
+       }
+}
 if (@failed) {
        exit 1;
 }
@@ -512,7 +573,10 @@ sub loadconfig { #{{{
 
                # copy in defaults from first parent
                my $parent=$dir;
-               while ($parent=~s/^(.*)\/[^\/]+\/?$/$1/) {
+               while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
+                       if ($parent eq '/') {
+                               $parent="";
+                       }
                        if (exists $config{$parent} &&
                            exists $config{$parent}{DEFAULT}) {
                                $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
@@ -527,8 +591,10 @@ sub loadconfig { #{{{
        close $in;
 
        my $section;
+       my $line=0;
        while (@lines) {
                $_=shift @lines;
+               $line++;
                chomp;
                next if /^\s*\#/ || /^\s*$/;
                if (/^\[([^\]]*)\]\s*$/) {
@@ -541,6 +607,7 @@ sub loadconfig { #{{{
                        # continued value
                        while (@lines && $lines[0]=~/^\s(.+)/) {
                                shift(@lines);
+                               $line++;
                                $value.="\n$1";
                                chomp $value;
                        }
@@ -565,14 +632,25 @@ sub loadconfig { #{{{
                                $knownactions{$parameter}=1;
                                if ($parameter eq 'chain' &&
                                    length $dir && $section ne "DEFAULT" &&
-                                   -e $dir.$section."/.mrconfig" &&
-                                   system($value) >> 8 == 0) {
-                                       push @toload, $dir.$section."/.mrconfig";
+                                   -e $dir.$section."/.mrconfig") {
+                                       my $ret=system($value);
+                                       if ($ret != 0) {
+                                               if (($? & 127) == 2) {
+                                                       print STDERR "mr $action: chain test interrupted\n";
+                                                       exit 2;
+                                               }
+                                               elsif ($? & 127) {
+                                                       print STDERR "mr $action: chain test received signal ".($? & 127)."\n";
+                                               }
+                                       }
+                                       else {
+                                               push @toload, $dir.$section."/.mrconfig";
+                                       }
                                }
                        }
                }
                else {
-                       die "$f line $.: parse error\n";
+                       die "$f line $line: parse error\n";
                }
        }
 
@@ -778,21 +856,21 @@ register =
                        error "cannot determine svn url"
                fi
                echo "Registering svn url: $url"
-               mr config "$(pwd)" checkout="svn co $url $basedir"
+               mr -c "$MR_CONFIG" config "$(pwd)" checkout="svn co $url $basedir"
        elif [ -d .git ]; then
                url=$(LANG=C git-config --get remote.origin.url)
                if [ -z "$url" ]; then
                        error "cannot determine git url"
                fi
                echo "Registering git url: $url"
-               mr config "$(pwd)" checkout="git clone $url $basedir"
+               mr -c "$MR_CONFIG" config "$(pwd)" checkout="git clone $url $basedir"
        elif [ -d .bzr ]; then
                url=$(cat .bzr/branch/parent)
                if [ -z "$url" ]; then
                        error "cannot determine bzr url"
                fi
                echo "Registering bzr url: $url"
-               mr config "$(pwd)" checkout="bzr clone $url $basedir"
+               mr -c "$MR_CONFIG" config "$(pwd)" checkout="bzr clone $url $basedir"
        else
                error "unable to register this repo type"
        fi
@@ -806,4 +884,5 @@ config =
 
 ed = echo "A horse is a horse, of course, of course.."
 T = echo "I pity the fool."
+right = echo "Not found."
 #}}}